package edu.mermet.tp8.fenetres;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import edu.mermet.tp8.Application;
import edu.mermet.tp8.actions.ActionAidePopupMenu;
import edu.mermet.tp8.ecouteurs.EcouteurMouseListenerIcon;
import edu.mermet.tp8.ecouteurs.EcouteurMouseListenerPopUpMenu;
import edu.mermet.tp8.ecouteurs.EcouteurMouseListenerText;

/**
 *
 * @author brunomermet
 */
public class FenetreConversion extends AbstractFenetreInterne {
    private JTextField champCelsius;
    private JTextField champFarenheit;
    private JButton boutonConvertir;
    private Action actionConvertir;
    private boolean celsiusAFocus;
    private JPopupMenu popUpMenu;
    
    public FenetreConversion(Action action) {
        super(action,"Conversion celsius/Farenheit");
        this.setSize(new Dimension(100,50));
        this.setLayout(new GridLayout(3,1));

        ImageIcon icon = new ImageIcon("src/main/java/edu/mermet/tp8/image/icon.png");
        Image helpImage = icon.getImage();
        Image scaledImage = helpImage.getScaledInstance(15, 15, Image.SCALE_DEFAULT);
        ImageIcon newInstance = new ImageIcon(scaledImage);

        JPopupMenu popupMenu = new JPopupMenu();
        JMenuItem menuCelsius = new JMenuItem( "Aide Celsius" );
        menuCelsius.setIcon(newInstance);
        menuCelsius.addActionListener(new ActionAidePopupMenu(this, "Valeur en degré Celsius"));
        popupMenu.add(menuCelsius);
        JMenuItem menuFarenheit = new JMenuItem( "Aide Farenheit" );
        menuFarenheit.setIcon(newInstance);
        menuFarenheit.addActionListener(new ActionAidePopupMenu(this, "Valeur en degré Farenheit"));
        popupMenu.add(menuFarenheit);

        JPanel ligneCelsius = new JPanel();
        ligneCelsius.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labCelsius = new JLabel("Celsius :");
        champCelsius = new JTextField(15);
        champCelsius.setToolTipText("Valeur en degré Celsius");
        champCelsius.addMouseListener(new EcouteurMouseListenerText(champCelsius));
        this.addMouseListener(new EcouteurMouseListenerPopUpMenu(popUpMenu));
        JLabel iconCelsius = new JLabel(newInstance);
        iconCelsius.setToolTipText("Aide Celsius");
        iconCelsius.addMouseListener(new EcouteurMouseListenerIcon(iconCelsius, "Valeur en degré Celsius"));
        labCelsius.setLabelFor(champCelsius);
        ligneCelsius.add(labCelsius);
        ligneCelsius.add(champCelsius);
        ligneCelsius.add(iconCelsius);
        this.add(ligneCelsius);
        celsiusAFocus = true;
        champCelsius.addFocusListener(new EcouteurFocus(true));
        JPanel ligneFarenheit = new JPanel();
        ligneFarenheit.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labFarenheit = new JLabel("Farenheit :");
        champFarenheit = new JTextField(15);
        champFarenheit.setToolTipText("Valeur en degré Farenheit");
        champFarenheit.addMouseListener(new EcouteurMouseListenerText(champFarenheit));
        this.addMouseListener(new EcouteurMouseListenerPopUpMenu(popUpMenu));
        JLabel iconFarenheit = new JLabel(newInstance);
        iconFarenheit.setToolTipText("Aide Farenheit");
        iconFarenheit.addMouseListener(new EcouteurMouseListenerIcon(iconFarenheit, "Valeur en degré Farenheit"));
        labFarenheit.setLabelFor(champFarenheit);        
        ligneFarenheit.add(labFarenheit);
        ligneFarenheit.add(champFarenheit);
        ligneFarenheit.add(iconFarenheit);
        this.add(ligneFarenheit);
        champFarenheit.addFocusListener(new EcouteurFocus(false));
        JPanel ligneValider = new JPanel();
        ligneValider.setLayout(new FlowLayout(FlowLayout.CENTER));
        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        ligneValider.add(boutonConvertir);
        this.add(ligneValider);
        
        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    private class EcouteurFocus implements FocusListener {
        private boolean aStocker;

        public EcouteurFocus(boolean b) {
            aStocker = b;
        }

        @Override
        public void focusGained(FocusEvent fe) {
            celsiusAFocus = aStocker;
        }

        @Override
        public void focusLost(FocusEvent fe) {
            return;
        }
    }

    private class ActionConvertir extends AbstractAction {

        public ActionConvertir() {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            double tempCelsius = 0;
            double tempFarenheit = 0;
            if (celsiusAFocus) {
                try {
                    tempCelsius = Double.parseDouble(champCelsius.getText());
                tempFarenheit = 9./5*tempCelsius+32;
                champFarenheit.setText(""+tempFarenheit);
                }
                catch (NumberFormatException nfe) {
                    champFarenheit.setText("Format incorrect");
                }
                }
            else {
                try {
                    tempFarenheit = Double.parseDouble(champFarenheit.getText());
                    tempCelsius = (tempFarenheit - 32) *5./9;
                    champCelsius.setText(""+tempCelsius);
                }
                catch (NumberFormatException nfe) {
                    champCelsius.setText("Format incorrect");
                }
                
            }
        }
    }
    
}
